﻿Public Class cStoreCallPickUp : Inherits cStoreRegistry

    Private Const CALL_PICKUP_GROUP_ROOT_PATH = "CallPickUpGroups\\"

    Public Sub New()

    End Sub

    '///////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////

    Public Function AddCallPickUpGroup(ByVal sCallPickUpGroupName As String) As Boolean

        If (sCallPickUpGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName
        MyBase.SetTEXT(sPath, "CallPickUpGroupName", sCallPickUpGroupName)

        Return True

    End Function

    Public Function RemoveCallPickUpGroup(ByVal sCallPickUpGroupName As String) As Boolean

        If (sCallPickUpGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName
        MyBase.DeleteSubKey(sPath)

        Return True

    End Function

    Public Function GetCallPickUpGroupNameAll(ByRef objListCallPickUpGroup As List(Of String)) As Boolean

        objListCallPickUpGroup.Clear()

        Dim sPath As String = CALL_PICKUP_GROUP_ROOT_PATH
        Return MyBase.EnumSubKeys(sPath, objListCallPickUpGroup)

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function AddCallPickUpGroupMember(ByVal sCallPickUpGroupName As String, ByVal sUserName As String) As Boolean

        If (sCallPickUpGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName + "\\" + sUserName

        Return MyBase.SetTEXT(sPath, "UserName", sUserName)

    End Function

    Public Function RemoveCallPickUpGroupMember(ByVal sCallPickUpGroupName As String, ByVal sUserName As String) As Boolean

        If (sCallPickUpGroupName.Length = 0 Or sUserName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName + "\\" + sUserName
        Return MyBase.DeleteSubKey(sPath)

    End Function

    Public Function GetPickUpMemberNameAll(ByVal sCallPickUpGroupName As String, ByRef objPickUpGroupAgentList As List(Of String)) As Boolean

        objPickUpGroupAgentList.Clear()

        Dim sPath As String = CALL_PICKUP_GROUP_ROOT_PATH + sCallPickUpGroupName
        Return MyBase.EnumSubKeys(sPath, objPickUpGroupAgentList)

    End Function

    Public Function IsDataStored() As Boolean
        Return MyBase.IsKeyExist(CALL_PICKUP_GROUP_ROOT_PATH)
    End Function

End Class
