﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cCallPickUpMemberDetails
    {
        public string m_sPickUpMemberName;

        public cCallPickUpMemberDetails()
        { 
        }
        ~cCallPickUpMemberDetails()
        { 
        }
    }
        
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    class cCallPickUpMemberList
    {
        Dictionary<string, cCallPickUpMemberDetails> m_objCallPickupMemberList = new Dictionary<string, cCallPickUpMemberDetails>();
        
        public bool AddMember(string sMemberName)
        {
            cCallPickUpMemberDetails objDetails = null;
            m_objCallPickupMemberList.TryGetValue(sMemberName, out objDetails);

            if(objDetails == null)
            {
                objDetails = new cCallPickUpMemberDetails();
                m_objCallPickupMemberList.Add(sMemberName, objDetails);
            }

            objDetails.m_sPickUpMemberName = sMemberName;
            return true;
        }
        public void RemoveMember(string sMemberName)
        {
            if(!IsGroupMember(sMemberName))
                return;

            m_objCallPickupMemberList.Remove(sMemberName);
        }

        public bool GetMemberList(ref List<string> sCallPickupMemberList)
        {
            cCallPickUpMemberDetails objDetails = null;

            foreach (KeyValuePair<string, cCallPickUpMemberDetails> objPickUpMemberName in m_objCallPickupMemberList)
            {
                objDetails = objPickUpMemberName.Value;
                sCallPickupMemberList.Add(objDetails.m_sPickUpMemberName);
            }

            return true;
        }

        public bool IsGroupMember(string sMemberName)
        {
            cCallPickUpMemberDetails objDetails = null;

            m_objCallPickupMemberList.TryGetValue(sMemberName, out objDetails);

            if(objDetails == null)
                return false;

            return true;
        }
    }
}
